'AKKUS_01.BAS: Akku-Schutz mit EIN-AUS-Taster, hier fr FA-Artikel
'Prg-Funktion: Die Baugruppe schaltet ber ein Relais einen 6V-Bleigelakku an einen
          'Verbraucher. Im Ausgeschalteten Zustand ist der Stromverbrauch 0.
          'ber eine Taste kann das Relais aktiviert werden. Nach dem Zuschalten
          'wird die Akkuspannung berwacht und beim Unterschreiten der Entlade-
          'schlussspannung das Relais deaktiviert. Bei einem EIN-Zustand lnger
          'als 5 Stunden wird automatisch AUS-geschaltet. Beim Unterschreiten von
          'ca. 5,8 V beginnt die LED zu blinken.
'Stand:  im Test 20071010
'Letzte Aenderung:
'Software:  'Quelle...\0205.BAS
'Hardware: siehe BG 20070801 Stand: nach Camping 2007
'###############################################################################
'C-Deklaration:
$regfile = "M8def.dat"
'-------------------------------------------------------------------------------
'Quarz 32kHz:
$crystal = 32000
'-------------------------------------------------------------------------------
'Digitale Ein- und Ausgaenge:
      'DDRx: x ist der betreffende Port a, b, c oder d
      'Eingang: 0, Ausgang:1
      '         76543210 Wertigkeit
      'Ddra = &B00000000
      'PullUp-R mit 1 aktivieren, mit 0 ohne PullUp-R
      'Porta = &B11111111
      'neuervariablenname ALIAS altervariablenname

'Port A: nicht vorhanden
'
'Port B:
         'PB.7: eventuell Quarz
         'PB.6: eventuell Quarz
         'PB.5: ISP
         'PB.4: ISP
         'PB.3: ISP
         'PB.2: frei
         'PB.1: Ausgang, LED
         'PB.0: frei

                    '76543210
            Ddrb = &B00000010
           Portb = &B11111101
           Led Alias Portb.1
           Led = 1
'
'Port C:
         'PC.7: nicht vorhanden
         'PC.6: ISP/Reset
         'PC.5: frei
         'PC.4: frei
         'PC.3: frei
         'PC.2: frei
         'PC.1: ADC1/Akkuspannung
         'PC.0: frei

                    '76543210
            Ddrc = &B00000000
           Portc = &B01111101
'
'Port D:
         'PD.7: Eingang/Taste
         'PD.6: frei
         'PD.5: Ausgang/fr Test der Programmlaufzeit
         'PD.4: frei
         'PD.3: Ausgang/Relais
         'PD.2: frei
         'PD.1: frei
         'PD.0: frei

                    '76543210
            Ddrd = &B00101000
           Portd = &B11010111
           Relais Alias Portd.3
           Relais = 1

'Port E: nicht vorhanden
'-------------------------------------------------------------------------------
'Variablen-Definition:
      Dim Status_byte As Byte
      'Status_byte.7:
      'Status_byte.6:
      'Status_byte.5:
      'Status_byte.4:
      'Status_byte.3:
      'Status_byte.2: aktueller Tastenstatus: =0:Taste ist gedruckt
                                             '=1:Taste ist losgelassen
      'Status_byte.1: =0:Taste war zuletzt losgelassen,
                     '=1:Taste war zuletzt gedrckt
      'Status_byte.0: =1, Akku kann zugeschaltet werden

      Dim Akku_ein_zeit_long As Long

'Hilfsvariablen:
      Dim Word1 As Word

'Konstanten:
      'CONST conname = conwert
'-------------------------------------------------------------------------------
'Konfiguration des Analog-Digital-Konverter
        'Single : Nur eine Konvertierung wird Durchgefhrt , Dauert etwas lnger
                 'als Free
        'Prescaler = Auto : Compiler legt Teiler fr Quarzfrequenz selbst fest
        'Reference = Internal : Interene Spannugsreferenz des C wird benutzt
                               '= 2,56V
        '                       Beachten, bei Single-Mode wird die interne
                               'RefSpanQuelle nur zur Messung eingeschaltet.
        Config Adc = Single , Prescaler = Auto , Reference = Internal
        Start Adc
'        Word=Getadc(x)
'        Stop Adc
'Umsetzung des Wertes der Speisespannung: 5,30V/680Digit=7.794117mV/Digit
'-------------------------------------------------------------------------------
'Programm - Beginn:
'-------------------------------------------------------------------------------
'Warten, bis die Taste losgelassen ist:
      Do
         Waitms 100
      'So lange die Taste noch gedrckt ist, ist Pind.7 nicht =1 und die Schleife
      'wird nicht verlassen.
      Loop Until Pind.7 = 1

      Status_byte.2 = 1
      'Status_byte.7:
      'Status_byte.6:
      'Status_byte.5:
      'Status_byte.4:
      'Status_byte.3:
      'Status_byte.2: aktueller Tastenstatus: =1:Taste ist losgelassen
      'Status_byte.1: =0:Taste war zuletzt losgelassen, =1:Taste war zuletzt gedrckt
      'Status_byte.0: =1, Akku kann zugeschaltet werden
'-------------------------------------------------------------------------------
'Jetzt ist C gestartet, Relais angezogen, LED ein und Taste losgelassen
'-------------------------------------------------------------------------------
'Wartezeit, damit der Kondensator an ADC(1) sicher aufgeladen ist
      Wait 1
'-------------------------------------------------------------------------------
'Variablen setzen:

      Akku_ein_zeit_long = 0
      'Der Zhler fr die Zeit in der der Akku seit dem letzten Einschalten
      'zugeschaltet ist.
'-------------------------------------------------------------------------------
'Beginn der Programmschleife, die immer wieder durchlaufen wird.
Main:
'-------------------------------------------------------------------------------
'Akku-Ist-Spannung holen
      'Der ADC(1)-Wert wird 2 mal geholt. damit ist sicher der aktuelle Wert in Word1
      Word1 = Getadc(1)
      Waitms 100
      Word1 = Getadc(1)
'-------------------------------------------------------------------------------
'Prfen, ob der Akku fast leer ist
       If Word1 < 750 Then
            '<5,95 Volt und > 5,3 V: Akku fast leer
            'LED blinken lassen
            Toggle Led
       Else
           Led = 1
      'End If fr: If Word1 < 750 Then
      End If
'-------------------------------------------------------------------------------
'Prfen, ob Akku leer ist:
      If Word1 < 680 Then
         '<5,3 Volt, Akku ist leer
         'Relais abfallen lassen
         Portd.3 = 0
      'End if fr: If Word1 < 680 Then
      End If
'-------------------------------------------------------------------------------
'Taste abfragen
      Status_byte.2 = Pind.7
      'Status_byte.2: aktueller Tastenstatus: =0:Taste ist gedrckt
      '                                       =1:Taste ist losgelassen
'-------------------------------------------------------------------------------
'Prfen, ob Wechsel von "Taste losgelassen zu Taste gedrckt"
      If Status_byte.2 = 0 And Status_byte.1 = 0 Then
            'Status_byte.2 = 0: Taste ist gedrckt
            'Status_byte.1 = 0: Taste war bisher losgelassen
            'Taste war bisher nicht gedrckt und ist jetzt gedrckt.
            'Taste als zuletzt gedrckt markieren
            Status_byte.1 = 1
      End If
'-------------------------------------------------------------------------------
'"Programmbremse", z.B. um den Zahlenwert bei Akku_ein_zeit_long nicht zu gross
'werden zu lassen.
      Waitms 100
'-------------------------------------------------------------------------------
'Prfen, ob Wechsel von "Taste gedrckt zu Taste losgelassen"
      If Status_byte.2 = 1 And Status_byte.1 = 1 Then
            'Status_byte.2 = 1: Taste ist losgelassen
            'Status_byte.1 = 1: Taste war bisher gedrckt
            'Gert war bisher eingeschaltet. Es wurde die Taste bettigt also
            'soll nun ausgeschaltet werden.
            'Ausgeschaltet wird, wenn die Taste losgelassen wird, also jetzt:
            'Relais soll abfallen
            Relais = 0
            'Hier ist unsauber programmiert! Siehe Artikel im Funkamateur.
      End If
'-------------------------------------------------------------------------------
'Prfen, ob die EIN - Zeit berschritten ist.
      If Akku_ein_zeit_long > 144000 Then
            '125 Sekunden/1000=0,125s
            '5 Stunden*3600/0,125=18000/0,125=18000*8=144000
            'EIN - Zeit ist berschritten, Relais soll abfallen
            Relais = 0
      End If
'-------------------------------------------------------------------------------
'Akku_ein_zeit_long bei jedem Programmschleifendurchlauf um 1 erhhen. Damit wird
'die Betriebszeit des Akkus messbar.
      Akku_ein_zeit_long = Akku_ein_zeit_long + 1
'-------------------------------------------------------------------------------
'Testausgang zur Programmzeit-Messung
      Toggle Portd.5
'-------------------------------------------------------------------------------
'Sprung zur Marke Main
      Goto Main
'-------------------------------------------------------------------------------
'Programmende
      End
'-------------------------------------------------------------------------------